// cw.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "cw.h"

#include "mainfrm.h"
#include "cwdoc.h"
#include "cwview.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// .INI File Data

static char BASED_CODE szSettings[] = "Settings";
static char BASED_CODE szTabStops[] = "TabStops";

static int defTabStops = 8;




/////////////////////////////////////////////////////////////////////////////
// CCwApp

BEGIN_MESSAGE_MAP(CCwApp, CWinApp)
	//{{AFX_MSG_MAP(CCwApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCwApp construction

CCwApp::CCwApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CCwApp object

CCwApp NEAR theApp;

/////////////////////////////////////////////////////////////////////////////
// CCwApp initialization

BOOL CCwApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

	SetDialogBkColor();        // set dialog background color to gray
	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	LoadINIData();				// Load Other INI Data
	
	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	AddDocTemplate(new CMultiDocTemplate(IDR_CWTYPE,
			RUNTIME_CLASS(CCwDoc),
			RUNTIME_CLASS(CMDIChildWnd),        // standard MDI child frame
			RUNTIME_CLASS(CCwView)));

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	pMainFrame->ShowWindow(SW_SHOWMAXIMIZED);
	pMainFrame->MDIIconArrange();
	pMainFrame->UpdateWindow();
	m_pMainWnd = pMainFrame;

	// create a new (empty) document
	// OnFileNew();

	if (m_lpCmdLine[0] != '\0')
	{
		// TODO: add command line processing here
	}

	return TRUE;
}


int CCwApp::ExitInstance()
{
	SaveINIData();	
	return CWinApp::ExitInstance();
}

/////////////////////////////////////////////////////////////////////////////
// CCwApp commands

void CCwApp::LoadINIData()
{                
	m_tabStops = GetProfileInt(szSettings,szTabStops,defTabStops);
}

void CCwApp::SaveINIData()
{
	WriteProfileInt(szSettings,szTabStops,m_tabStops);
}

// App command to run the dialog
void CCwApp::OnAppAbout()
{
	CDialog aboutDlg("ABOUTBOX");
	aboutDlg.DoModal();
}

