// cwfrmdlg.cpp : implementation file
//

#include "stdafx.h"
#include "cw.h"
#include "cwfrmdlg.h"

#include "cwdlg.h"		// CCodeFileDialog definition
#include "cwdata.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CSelectOpponentsDlg dialog

CSelectOpponentsDlg::CSelectOpponentsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectOpponentsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectOpponentsDlg)
	m_1stPath = "";
	m_2ndPath = "";
	//}}AFX_DATA_INIT
}

void CSelectOpponentsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectOpponentsDlg)
	DDX_Text(pDX, IDC_PATH1, m_1stPath);
	DDX_Text(pDX, IDC_PATH2, m_2ndPath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSelectOpponentsDlg, CDialog)
	//{{AFX_MSG_MAP(CSelectOpponentsDlg)
	ON_BN_CLICKED(IDC_BROWSE1, OnFirstBrowse)
	ON_BN_CLICKED(IDC_BROWSE2, OnSecondBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectOpponentsDlg message handlers

BOOL CSelectOpponentsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	CenterWindow();
	return TRUE;
}

void CSelectOpponentsDlg::OnFirstBrowse()
{
	CCodeFileDialog dlg("Browse Coded File",TRUE);
	
	if (dlg.DoModal()==IDOK)
	{
		m_1stPath = dlg.GetPathName();
		m_1stPath.MakeLower();
		GetDlgItem(IDC_PATH1)->SetWindowText(m_1stPath);
	}
}

void CSelectOpponentsDlg::OnSecondBrowse()
{
	CCodeFileDialog dlg("Browse Coded File",TRUE);
	
	if (dlg.DoModal()==IDOK)
	{
		m_2ndPath = dlg.GetPathName(); 
		m_2ndPath.MakeLower();
		GetDlgItem(IDC_PATH2)->SetWindowText(m_2ndPath);
	}
}





/////////////////////////////////////////////////////////////////////////////
// CStatisticsDlg dialog

CStatisticsDlg::CStatisticsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStatisticsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStatisticsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

void CStatisticsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStatisticsDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CStatisticsDlg, CDialog)
	//{{AFX_MSG_MAP(CStatisticsDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStatisticsDlg message handlers

BOOL CStatisticsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Set Controls Text
	GetDlgItem(IDC_NAME1)->SetWindowText(m_nameP1);
	GetDlgItem(IDC_NAME2)->SetWindowText(m_nameP2);

	SetDlgItemInt(IDC_WINS1,m_winsP1);
	SetDlgItemInt(IDC_WINS2,m_winsP2);
	SetDlgItemInt(IDC_DRAWS1,m_drawsP1);
	SetDlgItemInt(IDC_DRAWS2,m_drawsP2);
	SetDlgItemInt(IDC_LOSSES1,m_lossesP1);
	SetDlgItemInt(IDC_LOSSES2,m_lossesP2);
	SetDlgItemInt(IDC_SCORE1,m_scoreP1);
	SetDlgItemInt(IDC_SCORE2,m_scoreP2);
		
	CenterWindow();
	return TRUE;
}





/////////////////////////////////////////////////////////////////////////////
// CBattleDlg dialog

CBattleDlg::CBattleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBattleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBattleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

BOOL CBattleDlg::Create(CWnd* pParent /*=NULL*/)
{
	return CDialog::Create(CBattleDlg::IDD, pParent);
}

void CBattleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBattleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBattleDlg, CDialog)
	//{{AFX_MSG_MAP(CBattleDlg)
	ON_BN_CLICKED(IDC_ABORT, OnClickedAbort)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBattleDlg message handlers
BOOL CBattleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Button Flag
	m_abort = FALSE;

	CenterWindow();
	return TRUE;
}

void CBattleDlg::SetBattleSteps(UINT nBattle)
{
	SetDlgItemInt(IDC_BATTLE,nBattle,FALSE);
	GetDlgItem(IDC_BATTLE)->RedrawWindow();
}

void CBattleDlg::SetStepsDone(UINT nSteps)
{
	SetDlgItemInt(IDC_STEPS,nSteps,FALSE);
	GetDlgItem(IDC_STEPS)->RedrawWindow();
}

BOOL CBattleDlg::WasAbortButtonPressed()
{
	// Dispatch All Window Messages
	// (There May Be the BUTTON_CLICKED One...)
	MSG msg;
	
	while (PeekMessage(&msg,GetSafeHwnd(),0,0,PM_REMOVE))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	
	// Redraw Parent Window if Needed
	GetParent()->UpdateWindow();
	
	return m_abort;
}

void CBattleDlg::OnClickedAbort()
{
	// Button Pressed!
	m_abort = TRUE;
}





/////////////////////////////////////////////////////////////////////////////
// CCoreWarDlg dialog

CCoreWarDlg::CCoreWarDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCoreWarDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCoreWarDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

BOOL CCoreWarDlg::Create(CWnd* pParent /*=NULL*/)
{
	return CDialog::Create(CCoreWarDlg::IDD, pParent);
}

void CCoreWarDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCoreWarDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCoreWarDlg, CDialog)
	//{{AFX_MSG_MAP(CCoreWarDlg)
	ON_BN_CLICKED(IDC_ABORT, OnClickedAbort)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCoreWarDlg message handlers

BOOL CCoreWarDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Button Flag
	m_abort = FALSE;

	CenterWindow();
	return TRUE;
}

void CCoreWarDlg::SetStepsDone(UINT nSteps)
{
	SetDlgItemInt(IDC_STEPS,nSteps,FALSE);
	GetDlgItem(IDC_STEPS)->RedrawWindow();
}

void CCoreWarDlg::SetBattlesDone(UINT nBattles)
{
	SetDlgItemInt(IDC_BATTLENO,nBattles,FALSE);
	GetDlgItem(IDC_BATTLENO)->RedrawWindow();
}

void CCoreWarDlg::SetTotalBattles(UINT nTotBattles)
{
	SetDlgItemInt(IDC_BATTLES,nTotBattles,FALSE);
	GetDlgItem(IDC_BATTLES)->RedrawWindow();
}

BOOL CCoreWarDlg::WasAbortButtonPressed()
{
	// Dispatch All Window Messages
	// (There May Be the BUTTON_CLICKED One...)
	MSG msg;
	
	while (PeekMessage(&msg,GetSafeHwnd(),0,0,PM_REMOVE))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	
	// Redraw Parent Window if Needed
	GetParent()->UpdateWindow();
	
	return m_abort;
}

void CCoreWarDlg::OnClickedAbort()
{
	m_abort = TRUE;
}





/////////////////////////////////////////////////////////////////////////////
// CSettingsDlg dialog

CSettingsDlg::CSettingsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSettingsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSettingsDlg)
	m_programsGap = 0;
	m_warBattles = 0;
	m_progMaxTasks = 0;
	m_coreSize = 0;
	m_battleSteps = 0;
	m_y = 0;
	//}}AFX_DATA_INIT
}

void CSettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Gap(pDX, IDC_GAP, m_programsGap);
	DDV_MinMaxUInt(pDX, m_programsGap, 1, MAX_CORE_PROGRAMS_GAP);
	DDX_Text(pDX, IDC_BATTLES, m_warBattles);
	DDV_MinMaxUInt(pDX, m_warBattles, 1, MAX_CORE_WAR_BATTLES);
	DDX_Text(pDX, IDC_CORESIZE, m_coreSize);
	DDV_MinMaxUInt(pDX, m_coreSize, 1, MAX_CORE_SIZE);
	DDX_Text(pDX, IDC_STEPS, m_battleSteps);
	DDV_MinMaxUInt(pDX, m_battleSteps, 1, MAX_CORE_WAR_BATTLE_STEPS);
	DDX_Text(pDX, IDC_TASKS, m_progMaxTasks);
	DDV_MinMaxUInt(pDX, m_progMaxTasks, 1, MAX_CORE_PROGRAMS_TASKS);
	//{{AFX_DATA_MAP(CSettingsDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSettingsDlg, CDialog)
	//{{AFX_MSG_MAP(CSettingsDlg)
	ON_BN_CLICKED(IDC_DEFAULT, OnClickedDefault)
	ON_BN_CLICKED(IDC_SAVE, OnClickedSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSettingsDlg message handlers

BOOL CSettingsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	CenterWindow();
	return TRUE;
}

void CSettingsDlg::OnClickedDefault()
{
	// Load Defaults Values
	m_coreSize = MAX_CORE_SIZE;
	m_warBattles = MAX_CORE_WAR_BATTLES;
	m_battleSteps = MAX_CORE_WAR_BATTLE_STEPS;
	m_programsGap = MAX_CORE_PROGRAMS_GAP;
	m_progMaxTasks = MAX_CORE_PROGRAMS_TASKS;

	// Set Dialog Data
	UpdateData(FALSE);	
}

void CSettingsDlg::OnClickedSave()
{
	// Retrieve Dialog Data
	UpdateData(TRUE);	
	
	CWinApp* pApp = AfxGetApp();
	pApp->WriteProfileInt(CORE_SECTION,SIZE_ENTRY,m_coreSize);	
	pApp->WriteProfileInt(CORE_SECTION,BATTLES_ENTRY,m_warBattles);	
	pApp->WriteProfileInt(CORE_SECTION,STEPS_ENTRY,m_battleSteps);	
	pApp->WriteProfileInt(CORE_SECTION,GAP_ENTRY,m_programsGap);	
}

void AFXAPI CSettingsDlg::DDX_Gap(CDataExchange* pDX,
								  int nIDC,
								  int m_programsGap)
{
	HWND hWndCtrl = pDX->PrepareEditCtrl(nIDC);

	if (pDX->m_bSaveAndValidate)
	{
		int currGap = GetDlgItemInt(nIDC);
		int currSize = GetDlgItemInt(IDC_CORESIZE);
		
		if ((currGap<0)
			|| (currGap>currSize/4))
		{
			char buffer[8];
			CString msg = "Please enter an integer between 1 and ";
			msg += _itoa(currSize/4,buffer,10);			
			msg += "\n(gap must be less than one fourth of core size).";
			AfxMessageBox(msg,MB_ICONEXCLAMATION);
			pDX->Fail();
		}
	}
	else
		SetDlgItemInt(nIDC,m_programsGap);
}