// cwgraphs.h: CGraphCoreWnd interface 
/////////////////////////////////////////////////////////////////////////////


#ifndef __GRAPHCORE__
#define __GRAPHCORE__


#include "afxwin.h"		// CMDIChildWnd Definition		
#include "cwdata.h"		// Core Macros & Data Types


class CGraphCoreWnd : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CGraphCoreWnd)

public:
	CGraphCoreWnd();		// Default Constructor
	~CGraphCoreWnd();		// Default Destructor
	
	BOOL Create(const char*   wndTitle,
				int           nCoreSize, 
				CMDIFrameWnd* pParentFrame = NULL,
				DWORD         wndStyle  = 0);
	
	void EraseBackground(LPCRECT pRect = NULL);

protected:             
	// Protected Data          
	int		m_coreSize;
	BYTE	m_coreStatus[MAX_CORE_SIZE];
		
	// Window Size (in Core Cells)
	int		m_vertCells;
	int		m_horzCells;
	CSize	m_wndSize;		// Pixels

	// GDI Objects
	CBrush	m_bkBrush;
	
public:          
	void ClearAll();               
	void AccessedBy(CORE_ADDRESS addr, UINT nProg);                                              
	void ExecutedBy(CORE_ADDRESS addr, UINT nProg);                                              

// Implementation
protected:      
	void PaintCell(CORE_ADDRESS addr, COLORREF color);
	
	// Generated message map functions
	//{{AFX_MSG(CGraphCoreWnd)
	afx_msg void OnPaint();
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnInitMenu(CMenu* pMenu);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnWindowPosChanging(WINDOWPOS FAR* lpwndpos);
	//}}AFX_MSG
	
	DECLARE_MESSAGE_MAP()
};


#endif	// __GRAPHCORE__
