//   *******************************
//  *********************************
//  **                             **
//  **  DUMPWND Declaration File   **
//  **                             ** 
//  *********************************
//   *******************************

#ifndef _DUMP_WINDOW


#include "afxwin.h"		// CMDIChildWnd Declaration File
#include "afxcoll.h"	// CStringList  Declaration File


                                                        
#define	DEFAULT_TEXT_COLOR	RGB(0x00,0x00,0x00)
#define NULL_COLOR			(DWORD)(0xff000000)

#define HORZ_LINE	1
#define HORZ_PAGE	10

                                                        
                                                        
class CTextLine : public CObject
{
	DECLARE_DYNCREATE(CTextLine)

public:	
	CString 	m_text;
	CSize		m_Extents;
	COLORREF	m_color;

public:
	CTextLine();	// Default Constructor
};


          
class CDumpWnd : public CMDIChildWnd
{
	DECLARE_DYNCREATE(CDumpWnd)

public:
	CDumpWnd();		// Default Constructor
	~CDumpWnd();	// Default Destructor
	
	BOOL Create(const char*   wndTitle, 
				CMDIFrameWnd* pParentFrame = NULL,
				DWORD         wndStyle  = 0,
				const CRect&  wndRect = rectDefault,
				COLORREF      textColor = DEFAULT_TEXT_COLOR);

protected:             
	// Protected Data
	CObArray	m_text;			// Window Text
	
	// Zero-Based Counters
	int	m_firstLine;		// Index of the Top-Level Line
	int	m_currentRow;		// Row of the Last Line Drawn

	// One-Based Counters                           
	int	m_textLines;		// Total Number of Lines
	int	m_totalRows;		// Window Rows Number
                            
	// Scroll Bars Controls
	BOOL	m_HScroll;
	BOOL	m_VScroll;
	
	// Text Attributes
	COLORREF	m_textColor;
	int			m_textHeight;
	
	int			m_horzPosition;
	int			m_horzOffset;                     
	CSize		m_longestLineSize;
	
	// Window Attributes
	CRect		m_wndArea;		// Client Area Extents in Logical Units
	CBrush		m_eraseBrush;	// Deleting Brush                    
	                    
public:                         
	void ClearAll();                                              
	void SetTextColor(COLORREF color) { m_textColor = color; }
	void InsertLine(const char* newLine, COLORREF color=NULL_COLOR);

// Implementation
protected:      
	void DeleteContents();
	void UpdateWindowExtents();

	void EraseBackGround();
	void RedrawAllWindow();
	void DrawLine(int lineIndex);

	void InsertHScrollBar();
	void RemoveHScrollBar();
	void CheckHScrollBar();
	void InsertVScrollBar();
	void RemoveVScrollBar();  
	void CheckVScrollBar();
	
	// Generated message map functions
	//{{AFX_MSG(CDumpWnd)
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


#define _DUMP_WINDOW
#endif           
