// mainfrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////


#include "cwmars.h"		// M.A.R.S.
#include "cwtxtout.h"	// CDumpWnd Definition
#include "cwgraphs.h"	// CGraphCoreWnd Definition


class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

// Attributes
public:
	
// Operations
public:

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual	void AssertValid() const;
	virtual	void Dump(CDumpContext& dc) const;
#endif

protected:
	// control bar embedded members
	CStatusBar	m_wndStatusBar;
	CToolBar	m_wndToolBar;

	// Output Windows
	CDumpWnd*		m_pTextOutputWnd;
	CGraphCoreWnd*	m_pGraphOutputWnd;

	// M.A.R.S. Data
	UINT	m_coreSize;
	UINT	m_battleSteps;
	UINT	m_warBattles;
	UINT	m_programsGap;
	UINT	m_progMaxTasks;
	
	BOOL	m_firstBattleDone;
	BOOL	m_opponentsLoaded;

	CString	m_1stOpponentPath;
	CString	m_2ndOpponentPath;	
	
	// Last Battle Scoring
	int m_P1score;
	int m_P2score;
	int m_P1wins;
	int m_P2wins;
	int m_P1draws;
	int m_P2draws;
	int m_P1losses;
	int m_P2losses;
                             
	// M.A.R.S. Object
	CRedcodeSimulator	m_MARS;
	BOOL				m_validMARS;
	

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg void OnLoadOpponents();
	afx_msg void OnBattleSingle();
	afx_msg void OnUpdateBattleSingle(CCmdUI* pCmdUI);
	afx_msg void OnBattleCorewar();
	afx_msg void OnUpdateBattleCorewar(CCmdUI* pCmdUI);
	afx_msg void OnBattleStatistics();
	afx_msg void OnUpdateBattleStatistics(CCmdUI* pCmdUI);
	afx_msg void OnBattleParameters();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
